package cn.iocoder.yudao.module.system.service.worklog;

import cn.hutool.core.collection.CollectionUtil;
import cn.iocoder.yudao.module.system.controller.admin.worklog.dto.statistics.WorkLogStatisticsModelDTO;
import cn.iocoder.yudao.module.system.controller.admin.worklog.vo.statistics.WorkLogStatisticsModelVO;
import cn.iocoder.yudao.module.system.dal.dataobject.worklog.LogFormDO;
import cn.iocoder.yudao.module.system.dal.dataobject.worklog.LogRuleDO;
import cn.iocoder.yudao.module.system.dal.mysql.worklog.LogFormMapper;
import cn.iocoder.yudao.module.system.dal.mysql.worklog.LogUseMapper;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;
import java.util.*;
import java.util.stream.Collectors;

/**
 * 工作日志统计 Service 实现类
 *
 * @author 艾楷
 */
@Service
@Validated
public class WorkLogStatisticsServiceImpl implements WorkLogStatisticsService {
    @Resource
    private LogFormMapper logFormMapper;

    @Resource
    private LogRuleService logRuleService;

    @Resource
    private LogUseMapper logUseMapper;

    @Override
    public List<WorkLogStatisticsModelVO> myManageModel(WorkLogStatisticsModelDTO dto) {
        //获取模版ids - 当前登录用户的数据权限 查看日志模板使用者表
        // TODO: 2024/4/12 这里要测试下 数据权限问题
        List<Long> formIds = logUseMapper.getFormIdsByDataPermission();
        if (!formIds.isEmpty()) {
            return Collections.emptyList();
        }
        List<LogFormDO> formList = logFormMapper.selectList(new LambdaQueryWrapper<LogFormDO>()
                .in(LogFormDO::getId, formIds)
                .eq(LogFormDO::getStatus, 1)
                .isNotNull(LogFormDO::getRuleId)
        );
        List<Long> ruleIds = formList.stream().map(LogFormDO::getRuleId).collect(Collectors.toList());
        List<LogRuleDO> logRuleDOS = new ArrayList<>();
        Map<Long, LogRuleDO> ruleMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(ruleIds)) {
            logRuleDOS = logRuleService.getLogRuleByIds(ruleIds);
            ruleMap = logRuleDOS.stream().collect(Collectors.toMap(LogRuleDO::getId, v -> v));
        }
        for (LogFormDO logFormDO : formList) {
            LogRuleDO logRuleDO = ruleMap.get(logFormDO.getRuleId());
            //统计谁

        }
        return null;
    }
}